from population import Population
import time
import matplotlib.pyplot as plt

INCREASE_BY = 5
BRAIN_SIZE = 50
POP_SIZE = 50
MUTATION_FACTOR = 0.1  # 0 <= x <= 1
GAME_CANCELLED = False
LOAD_BRAIN = True
RENDER_BEST = False

if __name__ == '__main__':
    population = Population(POP_SIZE, BRAIN_SIZE,MUTATION_FACTOR, LOAD_BRAIN, RENDER_BEST)

    while GAME_CANCELLED is False:  # this is our game
        if population.all_players_finished():  # this is our genetic algorithm after one generation of players
            population.natural_selection()
            population.mutate_babies()
            population.increase_moves(INCREASE_BY)
            population.reset_environments()

            print(f'Gen: {population.gen}')
            print(f'Best Index: {population.best_walker_index}')
            print(f'Best Fitness: {population.fitnesses[population.best_walker_index]}')
            print(f'Max Steps: {population.max_steps}')
        else:
            population.update()
        # time.sleep(0.1)
